'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rcUpload = require('rc-upload');

var _rcUpload2 = _interopRequireDefault(_rcUpload);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

var _draftJsImportHtml = require('draft-js-import-html');

var _draftJsExportHtml = require('draft-js-export-html');

var _draftJs = require('draft-js');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function Filtrate(str) {
  return str.replace(/(\s*<p>\s*<br>\s*<\/p>\s*)(<figure>)|(<\/figure>)(\s*<p>\s*<br>\s*<\/p>\s*)/ig, function (_, $1, $2, $3) {
    return $2 == '<figure>' ? $2 : '</figure>';
  });
}

var Tinymce = function (_React$Component) {
  _inherits(Tinymce, _React$Component);

  function Tinymce(props) {
    _classCallCheck(this, Tinymce);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {
      editorState: _draftJs.EditorState.createEmpty()
    };
    _this.handleChange = _this._onChange.bind(_this);
    _this.handleClickImages = _this._insertImage.bind(_this);
    _this.handleClickSave = _this._handleClickSave.bind(_this);
    _this._imagesUploadSuccess = _this._imagesUploadSuccess.bind(_this);
    return _this;
  }

  Tinymce.prototype.componentWillMount = function componentWillMount() {
    if (this.props.rawContent) {
      var _editorState = this.state.editorState;
      var contentState = (0, _draftJsImportHtml.stateFromHTML)(this.props.rawContent);
      var editorState = _draftJs.EditorState.push(_editorState, contentState, 'change-block-data');
      this.setState({ editorState: editorState });
    }
  };

  Tinymce.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.rawContent && nextProps.rawContent !== this.props.rawContent) {
      var _editorState = this.state.editorState;
      var contentState = (0, _draftJsImportHtml.stateFromHTML)(nextProps.rawContent);
      var editorState = _draftJs.EditorState.push(_editorState, contentState, 'change-block-data');
      this.setState({ editorState: editorState });
    }
  };

  Tinymce.prototype._onChange = function _onChange(editorState) {
    this.setState({ editorState: editorState });
  };

  Tinymce.prototype._insertImage = function _insertImage(src, description) {
    this.handleChange((0, _utils.insertImages)(this.state.editorState, {
      src: src,
      description: description
    }));
  };
  /**
   * image 上传
   */

  Tinymce.prototype._imagesUploadSuccess = function _imagesUploadSuccess(res) {
    var uploadConfig = this.props.uploadConfig;

    if ('formatResult' in uploadConfig) {
      var result = uploadConfig.formatResult(res);
      this._insertImage(result.url, result.name);
    } else {
      throw "必须配置formatResult， 便于Tinymce接受上传后的图片";
    }
  };

  Tinymce.prototype.getHtmlContent = function getHtmlContent() {
    var _editorState = this.state.editorState.getCurrentContent();
    var _entityStyleFn = function _entityStyleFn(entity) {
      var entityType = entity.get('type').toLowerCase();
      if (entityType === 'image') {
        var data = entity.getData();
        return {
          element: 'img',
          attributes: {
            src: data.src,
            name: 'dhc-img'
          }
        };
      }
    };
    return (0, _draftJsExportHtml.stateToHTML)(_editorState, { entityStyleFn: _entityStyleFn });
  };

  Tinymce.prototype._handleClickSave = function _handleClickSave() {
    var _html = this.getHtmlContent();
    if (this.props.onSave) {
      this.props.onSave(Filtrate(_html));
      this.setState({ editorState: _draftJs.EditorState.createEmpty() });
    }
  };

  Tinymce.prototype.render = function render() {
    var _props = this.props,
        uploadConfig = _props.uploadConfig,
        footer = _props.footer,
        footerText = _props.footerText,
        innerElement = _props.innerElement,
        placeholder = _props.placeholder,
        onSnap = _props.onSnap;

    var uploadProps = _extends({
      prefixCls: "dh-upload",
      className: 'dh-tinymce-ctr'
    }, uploadConfig, {
      start: function start(file) {
        return console.log('onStart', file, file.name);
      },
      onSuccess: this._imagesUploadSuccess,
      onError: function onError() {
        return console.error('onError', err);
      }
    });
    return _react2.default.createElement(
      'div',
      { className: 'dh-tinymce' },
      _react2.default.createElement(
        'div',
        { className: 'dh-tinymce-btns' },
        _react2.default.createElement(
          _rcUpload2.default,
          uploadProps,
          _react2.default.createElement(_icon2.default, { type: 'tupian' }),
          ' '
        ),
        _react2.default.createElement(
          'span',
          { className: 'dh-tinymce-ctr', onClick: onSnap },
          _react2.default.createElement(_icon2.default, { type: 'kuaizhao' })
        )
      ),
      innerElement,
      _react2.default.createElement(
        'div',
        { className: 'dh-tinymce-edit' },
        _react2.default.createElement(_draftJs.Editor, {
          placeholder: placeholder,
          blockRendererFn: _utils.MediaBlockRenderer,
          editorState: this.state.editorState,
          onChange: this.handleChange
        })
      ),
      _react2.default.createElement(
        'div',
        { className: 'dh-tinymce-footer' },
        footer === true ? _react2.default.createElement(
          'div',
          { className: 'dh-tinymce-footer' },
          _react2.default.createElement(
            'span',
            { onClick: this.handleClickSave },
            footerText || '发送'
          )
        ) : null
      )
    );
  };

  return Tinymce;
}(_react2.default.Component);

Tinymce.defaultProps = {
  placeholder: '请输入文字.......',
  onSnap: function onSnap() {}
};
exports.default = Tinymce;