'use strict';

exports.__esModule = true;
exports.MediaBlockRenderer = exports.insertImages = undefined;

var _draftJs = require('draft-js');

var _component = require('./component.js');

var insertImages = exports.insertImages = function insertImages(editorState, data) {
  var contentState = editorState.getCurrentContent();
  var contentStateWithEntity = contentState.createEntity('image', 'IMMUTABLE', data);
  var entityKey = contentStateWithEntity.getLastCreatedEntityKey();
  var newEditorState = _draftJs.EditorState.set(editorState, { currentContent: contentStateWithEntity });
  return _draftJs.AtomicBlockUtils.insertAtomicBlock(newEditorState, entityKey, ' ');
};

var MediaBlockRenderer = exports.MediaBlockRenderer = function MediaBlockRenderer(block) {
  if (block.getType() === 'atomic') {
    return {
      component: _component.MediaBlock,
      editable: false
    };
  }
};